/*
 *  EXPRESSION, {akii-root}/src/expression.h
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#ifndef _EXPRESSION_H_
#define _EXPRESSION_H_ 1

enum kifenum {
    KIF_CONST, KIF_OP, KIF_FV, KIF_KIF, KIF_VAR
};
enum peeenum {
    PEE_NOTHING, PEE_OP, PEE_PRE, PEE_VPRE, PEE_VAR, PEE_CONST
};

#define BUNARY_PRE      0
#define BUNARY_POST     1
#define PL_BIUNARY      8
#define PL_UNARY        7
#define PL_MULTI        6

#define OP(x)           ((struct operators*)x)

struct kif {
    char tipus;			/*0:konstans, 1:valtozo, 2:operators, 3:fuggveny, 4:kifejezes */
    char *ertek;		/*konstans, valtozo neve, struct operators*, fv neve, kifejezes */
    char *param;		/*fv parameterek */
    struct kif *prev, *next;
    struct kif *szulo, *bal, *jobb;
};
struct operators {
    char nev[3];
    char pl;			/*precedencia szint */
    char *(*fv) (struct kif * kif);
};

extern struct kif *readkifinfix(char **s);
extern struct kif *mkpostkif(struct kif *kif);
extern void freeinfkif(struct kif *kif);
extern struct kif *readkif(char **s);
extern struct kif *mkkiffa(struct kif *kif);
extern void freekiffa(struct kif *kif);
extern char *dokif(struct kif *kif);

#endif
